diff --git a/gdb/testsuite/gdb.gdb/selftest.exp b/gdb/testsuite/gdb.gdb/selftest.exp
index 340137a..398a071 100644
--- a/gdb/testsuite/gdb.gdb/selftest.exp
+++ b/gdb/testsuite/gdb.gdb/selftest.exp
@@ -83,12 +83,12 @@ proc do_steps_and_nexts {} {
 		set description "step over ttyarg initialization"
 		set command "step"
 	    }
-	    -re ".*cmdarg_vec = NULL.*$gdb_prompt $" {
-		set description "step over cmdarg_vec initialization"
-		set command "step"
+	    -re ".*std::vector<struct cmdarg> cmdarg_vec.*$gdb_prompt $" {
+		set description "next over cmdarg_vec initialization"
+		set command "next"
 	    }
-	    -re ".*pre_stat_chain = make_command_stats_cleanup.*$gdb_prompt $" {
-		set description "next over make_command_stats_cleanup and everything it calls"
+	    -re ".*std::vector<char \\*> dirarg.*$gdb_prompt $" {
+		set description "next over dirarg initialization"
 		set command "next"
 	    }
 	    -re ".*START_PROGRESS.*$gdb_prompt $" {
@@ -98,10 +98,6 @@ proc do_steps_and_nexts {} {
 		set description "next over START_PROGRESS and everything it calls"
 		set command "next"
 	    }
-	    -re ".*mac_init.*$gdb_prompt $" {
-		set description "next over mac_init and everything it calls"
-		set command "next"
-	    }
 	    -re ".*init_malloc.*$gdb_prompt $" {
 		# gdb 6.2.X is the last gdb which called init_malloc
 		set description "next over init_malloc and everything it calls"
@@ -111,6 +107,10 @@ proc do_steps_and_nexts {} {
 		set description "next over lim_at_start initialization"
 		set command "next"
 	    }
+	    -re ".*scoped_command_stats stat_reporter .*$gdb_prompt $" {
+		set description "next over start_reporter"
+		set command "next"
+	    }
 	    -re ".*TRY.*$gdb_prompt $" {
 		set description "next over TRY"
 		set command "next"
@@ -119,23 +119,7 @@ proc do_steps_and_nexts {} {
 		set description "step into captured_main (args)"
 		set command "step"
 	    }
-	    -re ".*count . 0x3.*$gdb_prompt $" {
-		set description "next over conditional stack alignment code 1"
-		set command "next"
-	    }
-	    -re ".*if .i != 0.*$gdb_prompt $" {
-		set description "next over conditional stack alignment code 2"
-		set command "next"
-	    }
-	    -re ".*alloca .i - 4.*$gdb_prompt $" {
-		set description "next over conditional stack alignment alloca"
-		set command "next"
-	    }
-	    -re ".*dirsize = 1.*$gdb_prompt $" {
-		set description "next over dirsize initialization"
-		set command "next"
-	    }
-	    -re ".*dirarg = .* xmalloc.*$gdb_prompt $" {
+	    -re ".*saved_command_line = .* xstrdup.*$gdb_prompt $" {
 		return
 	    }
 	    -re ".*setlocale .LC_MESSAGES,.*$gdb_prompt $" {
@@ -184,10 +168,6 @@ proc do_steps_and_nexts {} {
 		set description "step over gdb_sysroot initialization"
 		set command "step"
 	    }
-	    -re ".*ndir = 0.*$gdb_prompt $" {
-		set description "step over ndir initialization"
-		set command "step"
-	    }
 	    -re ".*instream = stdin.*$gdb_prompt $" {
 		set description "step over instream initialization"
 		set command "step"
@@ -199,11 +179,7 @@ proc do_steps_and_nexts {} {
 	    -re ".*gdb_program_name = xstrdup.*$gdb_prompt $" {
                 set description "next over xstrdup"
                 set command "next"
-            } 
-            -re ".*quit_flag = 0.*$gdb_prompt $" {
-		set description "step over quit_flag initialization"
-		set command "step"
-	    }
+            }
 	    -re ".*gdb_stdout = stdio_fileopen .stdout.;.*$gdb_prompt $" {
 		set description "step over gdb_stdout initialization"
 		set command "step"
@@ -301,53 +277,6 @@ proc test_with_self { } {
 
     do_steps_and_nexts
 
-    gdb_test "print \"foo\"" ".\[0-9\]+ = \"foo\"" "print a string"
-
-    # do_steps_and_nexts left us ready to execute an xmalloc call,
-    # so give that a try.
-    # If we don't actually enter the xmalloc call when we give a
-    # step command that seems like a genuine bug.  It seems to happen
-    # on most RISC processors.
-    # NOTE drow/2003-06-22: However, if we step back to the preceding two
-    # lines, just keep stepping until we enter.
-    set stepped_back 0
-    setup_xfail "alpha-*-*" "mips-*-*"
-    set description "step into xmalloc call"
-    gdb_test_multiple "step" "$description" {
-	-re "ncmd = 0;.*$gdb_prompt $" {
-	    set stepped_back 1
-	    send_gdb "step\n"
-	    exp_continue
-	}
-        -re ".*cmdarg = .* xmalloc.*$gdb_prompt $" {
-	    set stepped_back 1
-	    send_gdb "step\n"
-	    exp_continue
-        }
-	-re "dirsize = 1;.*$gdb_prompt $" {
-	    set stepped_back 1
-	    send_gdb "step\n"
-	    exp_continue
-	}
-	-re ".*dirarg = .* xmalloc.*$gdb_prompt $" {
-	    if { $stepped_back == 1 } {
-		send_gdb "step\n"
-		exp_continue
-	    } else {
-		fail "$description"
-	    }
-	}
-	-re "xmalloc.*size=.*at.*utils.c.*$gdb_prompt $" {
-	    pass "$description"
-	}
-	-re ".*No such file or directory.\r\n$gdb_prompt $" {
-	    pass "$description (no source available)"
-	}
-	-re "A file or directory .* does not exist..\r\n$gdb_prompt $" {
-	    pass "$description (no source available)"
-	}
-    }
-
     # start the "xgdb" process
     if [target_info exists gdb,noinferiorio] {
 	# With no way to interact with the inferior GDB, all we can do